<?php
add_filter('get_term_metadata', function($null, $term_id, $meta_key) {
    if ($meta_key === 'thumbnail_id' && ($image = get_term_meta($term_id, 'WebPutanjaSlike', true))) {
        return sprintf('gath-%s', $image);
    }

    return $null;
}, 10, 3);

add_filter('wp_get_attachment_image_src', function($image, $attachment_id, $size) {
    if (preg_match('/^gath-(.*)$/', $attachment_id, $matches)) {
        if (strlen($matches[1]) > 0) {
            if (preg_match('/^external-(.*)$/', $matches[1], $matches2)) {
                $imageUrl = sprintf('/external/%s', $matches2[1]);
            } else {
                $imageUrl = inti_gath_get_ep_image_url($matches[1], $size);
            }
            return [$imageUrl, null, null];
        }
    }

    return $image;
}, 10, 3);

function inti_gath_get_ep_image_url ($path, $size = 'full', $cropped = false)
{
    $baseUri = 'https://img.carparts.hr';
    $parts = [];

    if ($size !== 'full') {
        if (is_string($size)) {
            global $_wp_additional_image_sizes;

            if (!isset($_wp_additional_image_sizes[$size]) && !in_array($size, ['thumbnail', 'medium', 'medium_large', 'large'])) {
                throw new \RuntimeException(sprintf("Nepoznata veličina slike '%s'.", $size));
            }

            if (in_array($size, ['thumbnail', 'medium', 'medium_large', 'large'])) {
                $width = get_option("{$size}_size_w");
                $height = get_option("{$size}_size_h");
                $cropped = (bool)get_option("{$size}_crop");
            } else {
                $width = $_wp_additional_image_sizes[$size]['width'];
                $height = $_wp_additional_image_sizes[$size]['height'];
                $cropped = $_wp_additional_image_sizes[$size]['crop'];
            }
        } else if (is_array($size)) {
            [$width, $height] = $size;
        } else {
            throw new \RuntimeException(sprintf(
                "Neispravan parametar \$size, mora biti string ili array a dobio sam %s.",
                is_object($size) ? get_class($size) : gettype($size)
            ));
        }

        $parts[] = sprintf('%sx%s', $width, $height);
    }

    if ($cropped) {
        array_unshift($parts, 'thumb');
    }

    $parts[] = implode('/', array_map('rawurlencode', explode('/', $path)));

    return sprintf('%s/%s', $baseUri, implode('/', $parts));
}
