<?php
namespace Inti\Gath\Hydrator\Moto;

use Laminas\Hydrator\NamingStrategy\MapNamingStrategy;
use Laminas\Hydrator\ReflectionHydrator;

/**
 * Class MotorcycleHydrator
 *
 * @package Inti\Gath\Hydrator\Moto
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath
 */
final class MotorcycleHydrator extends ReflectionHydrator
{
    /**
     * Konstruktor.
     */
    public function __construct()
    {
        $this->setNamingStrategy(MapNamingStrategy::createFromHydrationMap([
            'MotoId' => 'id',
            'BrandId' => 'manufacturerId',
            'ModelId' => 'modelId',
            'Year' => 'year',
            'Ccm' => 'engineCapacity',
            'Kw' => 'enginePowerKw',
            'Ks' => 'enginePowerHp',
        ]));
    }
}
