<?php
namespace Inti\Gath\Model\Entity;

/**
 * Svojstvo proizvoda.
 *
 * @package Inti\Gath\Model\Entity
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath
 */
final class Attribute
{
    /** @var int */
    private $id;
    /** @var string */
    private $name;
    /** @var string */
    private $slug;
    /** @var string[] */
    private $allValues;
    /** @var string|null */
    private $value;

    /**
     * @return int
     */
    public function getId(): int
    {
        return $this->id;
    }

    /**
     * @return string
     */
    public function getName(): string
    {
        return $this->name;
    }

    /**
     * @return string
     */
    public function getSlug(): string
    {
        if (empty($this->slug)) {
            $this->slug = sanitize_title($this->name);
        }

        return $this->slug;
    }

    /**
     * @return string|null
     */
    public function getValue(): ?string
    {
        return $this->value;
    }

    /**
     * @return string[]
     */
    public function getAllValues(): array
    {
        return $this->allValues;
    }
}
