<?php
namespace Inti\Gath\Model\Entity;

/**
 * Class Category
 *
 * @package Inti\Gath\Model\Entity
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath
 */
final class Category
{
    /** @var int */
    private $id = 0;
    /** @var int */
    private $parentId = 0;
    /** @var string */
    private $name = '';
    /** @var string */
    private $slug = '';
    /** @var int */
    private $order = 0;
    /** @var string */
    private $image = '';
    /** @var string */
    private $description = '';
    /** @var Category[] */
    private $children = [];
    /** @var bool */
    private $tireCategory = false;

    /**
     * @return int
     */
    public function getId(): int
    {
        return $this->id;
    }

    /**
     * @return int
     */
    public function getParentId(): int
    {
        return $this->parentId;
    }

    /**
     * @return string
     */
    public function getName(): string
    {
        return $this->name;
    }

    /**
     * @return string
     */
    public function getSlug(): string
    {
        return $this->slug;
    }

    /**
     * @return int
     */
    public function getOrder(): int
    {
        return $this->order;
    }

    /**
     * @return string
     */
    public function getImage(): string
    {
        return $this->image;
    }

    /**
     * @return string
     */
    public function getDescription(): string
    {
        return $this->description;
    }

    /**
     * @return Category[]
     */
    public function getChildren(): array
    {
        return $this->children;
    }

    /**
     * @return bool
     */
    public function isTireCategory(): bool
    {
        return $this->tireCategory;
    }
}
