<?php
namespace Inti\Gath\Model\Entity;

use DateTime;

/**
 * Class Product
 *
 * @package Inti\Gath\Model\Entity
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath
 */
class Product
{
    /** @var DateTime|null */
    protected $dateModified;
    /** @var string */
    protected $description = '';
    /** @var int */
    protected $id = 0;
    /** @var array */
    protected $images = [];
    /** @var string */
    protected $name = '';
    /** @var string */
    protected $shortDescription = '';
    /** @var string */
    protected $sku = '';
    /** @var string */
    protected $type = '';
    /** @var Attribute[] */
    protected $attributes = [];
    /** @var int[] */
    protected $categoryIds = [];

    /**
     * @return Attribute[]
     */
    public function getAttributes(): array
    {
        return $this->attributes;
    }

    /**
     * @return DateTime
     */
    public function getDateModified(): ?DateTime
    {
        return $this->dateModified;
    }

    /**
     * @return string
     */
    public function getDescription(): string
    {
        return $this->description;
    }

    /**
     * @return int
     */
    public function getId(): int
    {
        return $this->id;
    }

    /**
     * @return array
     */
    public function getImages(): array
    {
        return $this->images;
    }

    /**
     * @return string
     */
    public function getName(): string
    {
        return $this->name;
    }

    /**
     * @return string
     */
    public function getShortDescription(): string
    {
        return $this->shortDescription;
    }

    /**
     * @return string
     */
    public function getSku(): string
    {
        return $this->sku;
    }

    /**
     * @return string
     */
    public function getType(): string
    {
        return $this->type;
    }

    /**
     * @return int[]
     */
    public function getCategoryIds(): array
    {
        return $this->categoryIds;
    }
}
