<?php
namespace Inti\Gath\Model\Entity;

/**
 * Stanje zalihe proizvoda.
 *
 * @package Inti\Gath\Model\Entity
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath
 */
final class ProductStock
{
    /** @var int */
    private $productId;
    /** @var string */
    private $productSku;
    /** @var int */
    private $stock;
    /** @var int[] */
    private $stockByWarehouse = [];
    /** @var int */
    private $purchaseStep = 0;

    /**
     * @return int
     */
    public function getProductId(): int
    {
        return $this->productId;
    }

    /**
     * @return string
     */
    public function getProductSku(): string
    {
        return $this->productSku;
    }

    /**
     * @param string $warehouse
     * @return int
     */
    public function getStock(?string $warehouse = null): int
    {
        return $warehouse
            ? ($this->stockByWarehouse[$warehouse] ?? 0)
            : $this->stock;
    }

    /**
     * @return int
     */
    public function getPurchaseStep(): int
    {
        return $this->purchaseStep;
    }
}
