<?php
namespace Inti\Gath\Model\Entity;

/**
 * Class Tire
 *
 * @package Inti\Gath\Entity\Tire
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath
 */
final class Tire extends Product
{
    /** @var string */
    private $brand = '';
    /** @var string */
    private $vehicleType = '';
    /** @var string */
    private $season = '';
    /** @var int */
    private $width = 0;
    /** @var int */
    private $height = 0;
    /** @var int */
    private $diameter = 0;
    /** @var string */
    private $speedIndex = '';
    /** @var string */
    private $fuelEfficiency = '';
    /** @var string */
    private $wetBraking = '';
    /** @var int */
    private $noise = 0;
    /** @var int */
    private $loadIndex = 0;

    /**
     * @return string
     */
    public function getBrand(): string
    {
        return $this->brand;
    }

    /**
     * @return string
     */
    public function getVehicleType(): string
    {
        return $this->vehicleType;
    }

    /**
     * @return string
     */
    public function getSeason(): string
    {
        return $this->season;
    }

    /**
     * @return int
     */
    public function getWidth(): int
    {
        return $this->width;
    }

    /**
     * @return int
     */
    public function getHeight(): int
    {
        return $this->height;
    }

    /**
     * @return int
     */
    public function getDiameter(): int
    {
        return $this->diameter;
    }

    /**
     * @return string
     */
    public function getSpeedIndex(): string
    {
        return $this->speedIndex;
    }

    /**
     * @return string
     */
    public function getFuelEfficiency(): string
    {
        return $this->fuelEfficiency;
    }

    /**
     * @return string
     */
    public function getWetBraking(): string
    {
        return $this->wetBraking;
    }

    /**
     * @return int
     */
    public function getNoise(): int
    {
        return $this->noise;
    }

    /**
     * @return int
     */
    public function getLoadIndex(): int
    {
        return $this->loadIndex;
    }
}
