<?php
namespace Inti\Gath\Model\Hydrator;

use Laminas\Hydrator\NamingStrategy\MapNamingStrategy;
use Laminas\Hydrator\ReflectionHydrator;

/**
 * Class CategoryHydrator
 *
 * @package Inti\Gath\Model\Hydrator
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath
 */
final class CategoryHydrator extends ReflectionHydrator
{
    /**
     * Konstruktor.
     */
    public function __construct()
    {
        $this->setNamingStrategy(MapNamingStrategy::createFromHydrationMap([
            'Name' => 'name',
            'ParentDataLink' => 'parentId',
            'Description' => 'description',
            'Menu_order' => 'order',
            'Slug' => 'slug',
            'DataLink' => 'id',
            'Children' => 'children',
            'IsTyreCategory' => 'tireCategory',
        ]));

        $this->addStrategy('id', new Strategy\CategoryIdStrategy());
        $this->addStrategy('parentId', new Strategy\CategoryIdStrategy());
        $this->addStrategy('children', new Strategy\CategoryChildrenStrategy($this));
    }
}
