<?php
namespace Inti\Gath\Model\Hydrator;

use Psr\Container\ContainerInterface;
use Laminas\Hydrator\DelegatingHydrator;
use Laminas\Hydrator\HydratorPluginManager;

/**
 * Class ProductHydratorFactory
 *
 * @package Inti\Gath\Model\Hydrator
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/autokreso/warehouse
 */
final class ProductHydratorFactory
{
    public function __invoke(ContainerInterface $container)
    {
        /** @var HydratorPluginManager $hydrators */
        $hydrators = $container->get(HydratorPluginManager::class);
        $hydrator = $hydrators->get(DelegatingHydrator::class);

        return new ProductHydrator($hydrator);
    }
}
