<?php
namespace Inti\Gath\Model\Hydrator;

use Laminas\Hydrator\NamingStrategy\MapNamingStrategy;
use Laminas\Hydrator\ReflectionHydrator;

/**
 * Class ProductPriceHydrator
 *
 * @package Inti\Gath\Model\Hydrator
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath
 */
final class ProductPriceHydrator extends ReflectionHydrator
{
    /**
     * Konstruktor.
     */
    public function __construct()
    {
        $this->setNamingStrategy(MapNamingStrategy::createFromHydrationMap([
            'ProductCode' => 'productSku',
            'ProductId' => 'productId',
            'Currency' => 'currency',
            'PriceRetail' => 'regularPrice',
            'Discount' => 'salePrice',
            'HidePrice' => 'priceHidden',
        ]));

        $this->addStrategy('regularPrice', new Strategy\RegularPriceStrategy());
        $this->addStrategy('salePrice', new Strategy\SalePriceStrategy());
    }
}
