<?php
namespace Inti\Gath\Model\Hydrator;

use Inti\Gath\Model\Hydrator\Strategy\StockByWarehouseStrategy;
use Laminas\Hydrator\ReflectionHydrator;

/**
 * Class StockInfoHydrator
 *
 * @package Inti\Gath\Model\Hydrator
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath
 */
final class ProductStockHydrator extends ReflectionHydrator
{
    public function __construct()
    {
        $this->setNamingStrategy(new NamingStrategy\ProductStockNamingStrategy());
        $this->addStrategy('stockByWarehouse', new StockByWarehouseStrategy());
    }
}
