<?php
namespace Inti\Gath\Model\Hydrator\Strategy;

use Inti\Gath\Model\Entity\Category;
use Laminas\Hydrator\HydratorInterface;
use Laminas\Hydrator\Strategy\StrategyInterface;

/**
 * Class CategoryChildrenStrategy
 *
 * @package Inti\Gath\Model\Hydrator\Strategy
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath
 */
final class CategoryChildrenStrategy implements StrategyInterface
{
    /** @var HydratorInterface */
    private $categoryHydrator;

    /**
     * Konstruktor.
     *
     * @param HydratorInterface $categoryHydrator
     */
    public function __construct(HydratorInterface $categoryHydrator)
    {
        $this->categoryHydrator = $categoryHydrator;
    }

    /**
     * @inheritDoc
     */
    public function extract($value, ?object $object = null)
    {
        return $value;
    }

    /**
     * @inheritDoc
     */
    public function hydrate($value, ?array $data)
    {
        foreach ($value ?? [] as $categoryData) {
            $categories[] = $this->categoryHydrator->hydrate($categoryData, new Category());
        }

        return $categories ?? [];
    }
}
