<?php
namespace Inti\Gath\Model\Hydrator\Strategy;

use Laminas\Hydrator\Strategy\StrategyInterface;

/**
 * Class IdStrategy
 *
 * @package Inti\Gath\Model\Hydrator\Strategy
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath
 */
abstract class IdStrategy implements StrategyInterface
{
    const ID_OFFSET = 1e6;

    /**
     * @param mixed $value
     * @param object|null $object
     * @return mixed|void
     */
    public function extract($value, ?object $object = null)
    {
        $dataLink = intval($value - static::ID_OFFSET);
        return $dataLink > 0 ? $dataLink : 0;
    }

    /**
     * @param mixed $value
     * @param array|null $data
     * @return mixed|void
     */
    public function hydrate($value, ?array $data)
    {
        return is_numeric($value) && $value > 0
            ? intval($value + static::ID_OFFSET)
            : 0;
    }
}
