<?php
namespace Inti\Gath\Model\Hydrator\Strategy;

use Inti\Gath\Model\Entity\Attribute;
use Laminas\Hydrator\HydratorInterface;
use Laminas\Hydrator\Strategy\StrategyInterface;

/**
 * Class ProductAttributeStrategy
 *
 * @package Inti\Gath\Model\Hydrator\Strategy
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath
 */
final class ProductAttributesStrategy implements StrategyInterface
{
    /** @var HydratorInterface */
    private $attributeHydrator;

    /**
     * ProductAttributeStrategy constructor.
     * @param HydratorInterface $attributeHydrator
     */
    public function __construct(HydratorInterface $attributeHydrator)
    {
        $this->attributeHydrator = $attributeHydrator;
    }

    /**
     * @inheritDoc
     */
    public function extract($value, ?object $object = null)
    {
        return $value;
    }

    /**
     * @inheritDoc
     */
    public function hydrate($value, ?array $data)
    {
        foreach ($value ?? [] as $attributeData) {
            $attributes[] = $this->attributeHydrator->hydrate($attributeData, new Attribute());
        }

        return $attributes ?? [];
    }
}
