<?php
namespace Inti\Gath\Model\Hydrator\Strategy;

use Laminas\Hydrator\Strategy\StrategyInterface;

/**
 * Class ProductImagesStrategy
 *
 * @package Inti\Gath\Model\Hydrator\Strategy
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath
 */
final class ProductImagesStrategy implements StrategyInterface
{
    /**
     * @inheritDoc
     */
    public function extract($value, ?object $object = null)
    {
        return $value;
    }

    /**
     * @inheritDoc
     */
    public function hydrate($value, ?array $data)
    {
        $value = (array) $value;

        usort($value, function($a, $b) {
            if ($a['orderno'] === $b['orderno']) {
                return 0;
            }

            return $a['orderno'] < $b['orderno'] ? -1 : 1;
        });

        return array_map(function(array $image) {
            return $image['url'];
        }, $value);
    }
}
