<?php
namespace Inti\Gath\Model\Hydrator\Strategy;

/**
 * Class RegularPriceStrategy
 *
 * @package Inti\Gath\Model\Hydrator\Strategy
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath
 */
final class RegularPriceStrategy extends ProductPriceStrategy
{
    /**
     * @inheritDoc
     */
    public function hydrate($value, ?array $data)
    {
        if ($this->hasDiscount($data)) {
            $discount = $this->getBestDiscount($data);
            return $discount['OriginalRetail'];
        }

        if ($this->hasRebate($data)) {
            $rebate = $this->getBestRebate($data);
            return ($rebate['PriceWholesaleNetto'] ?? 0) ?: $rebate['PriceWholesale'];
        } else if (defined('GATH_WHOLESALE') && GATH_WHOLESALE === true) {
            return $data['PriceWholesale'];
        }

        return $value;
    }
}
