<?php
namespace Inti\Gath\Model\Hydrator\Strategy;

/**
 * Class SalePriceStrategy
 *
 * @package Inti\Gath\Model\Hydrator\Strategy
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath
 */
final class SalePriceStrategy extends ProductPriceStrategy
{
    /**
     * @inheritDoc
     */
    public function hydrate($value, ?array $data)
    {
        if ($this->hasDiscount($value)) {
            $discount = $this->getBestDiscount($data);
            return $discount['NewRetail'];
        }

        if ($this->hasRebate($data)) {
            $rebate = $this->getBestRebate($data);
            return $rebate['CalculatedNetto'];
        }

        return 0;
    }
}
