<?php
namespace Inti\Gath\Model\Hydrator\Strategy;

use Laminas\Hydrator\Strategy\StrategyInterface;

/**
 * Class StockByWarehouseStrategy
 *
 * @package Inti\Gath\Model\Hydrator\Strategy
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath
 */
final class StockByWarehouseStrategy implements StrategyInterface
{
    /**
     * @inheritDoc
     */
    public function extract($value, ?object $object = null)
    {
        return $value;
    }

    /**
     * @inheritDoc
     */
    public function hydrate($value, ?array $data)
    {
        foreach ($data ?? [] as $name => $value) {
            if (preg_match('/^Stock_(\d+)$/', $name, $matches)) {
                $stockByWarehouse[$matches[1]] = $value;
            }
        }

        return $stockByWarehouse ?? [];
    }
}
