<?php
namespace Inti\Gath\Model\Repository;

use Inti\Gath\Api\Endpoint\Service\EndpointManager;
use Laminas\Hydrator\HydratorInterface;

/**
 * Class AbstractRepository
 *
 * @package Inti\Gath\Model\Repository
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath
 */
abstract class AbstractRepository implements RepositoryInterface
{
    const ID_OFFSET = 1e6;

    /** @var EndpointManager */
    protected $endpoints;
    /** @var HydratorInterface */
    protected $hydrator;

    /**
     * Konstruktor.
     *
     * @param EndpointManager $endpoints
     * @param HydratorInterface $hydrator
     */
    public function __construct(EndpointManager $endpoints, HydratorInterface $hydrator)
    {
        $this->endpoints = $endpoints;
        $this->hydrator = $hydrator;
    }
}
