<?php
namespace Inti\Gath\Model\Repository;

use Inti\Gath\Model\Entity\Attribute;
use Inti\Gath\Model\Entity\Category;
use Laminas\ServiceManager\AbstractPluginManager;

/**
 * Class RepositoryManager
 *
 * @package Inti\Gath\Model\Repository
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath
 */
final class RepositoryManager extends AbstractPluginManager
{
    /** @var string */
    protected $instanceOf = RepositoryInterface::class;
    /** @var array */
    protected $aliases = [
        Attribute::class => AttributeRepository::class,
        Category::class => CategoryRepository::class,
    ];
    /** @var array */
    protected $factories = [
        AttributeRepository::class => RepositoryFactory::class,
        CategoryRepository::class => RepositoryFactory::class,
        ProductRepository::class => ProductRepositoryFactory::class,
        ProductPriceRepository::class => RepositoryFactory::class,
        ProductStockRepository::class => RepositoryFactory::class,
    ];
}
