<?php
namespace Inti\Gath\Model\Repository;

use Inti\Gath\Api\Endpoint\GetRimProperties;
use Inti\Gath\Api\Query\GetRimPropertiesQuery;
use Inti\Gath\Model\Entity\Property;

/**
 * Class RimPropertyRepository
 *
 * @package Inti\Gath\Repository
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-bartog
 */
final class RimPropertyRepository extends AbstractRepository
{
    /** @var Property[] */
    private $all;

    /**
     * @return Property[]
     */
    public function getAll(): array
    {
        if (!isset($this->all)) {
            /** @var GetRimProperties $endpoint */
            $endpoint = $this->endpoints->get(GetRimProperties::class);
            $result = $endpoint->call(new GetRimPropertiesQuery());

            $this->all = [];

            foreach ($result->Result as $name => $values) {
                $this->all[] = $this->hydrator->hydrate([
                    'name' => $name,
                    'values' => $values,
                ], new Property());
            }
        }

        return $this->all;
    }
}
