<?php
namespace Inti\Gath\Model\Repository;

use Inti\Gath\Api\Endpoint\GetTireProperties;
use Inti\Gath\Api\Query\GetTirePropertiesQuery;
use Inti\Gath\Model\Entity\Property;

/**
 * Class TireRepository
 *
 * @package Inti\Gath\Model\Repository
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-bartog
 */
final class TireRepository extends AbstractRepository
{
    /** @var Property[] */
    private $properties;

    /**
     * @return array
     */
    public function getAll(): array
    {
        return [];
    }

    /**
     * @return Property[]
     */
    public function getProperties(): array
    {
        if (!isset($this->properties)) {
            /** @var GetTireProperties $endpoint */
            $endpoint = $this->endpoints->get(GetTireProperties::class);
            $result = $endpoint->call(new GetTirePropertiesQuery());

            $this->properties = [];

            foreach ($result->Result as $name => $values) {
                $this->properties[] = $this->hydrator->hydrate([
                    'name' => $name,
                    'values' => $values,
                ], new Property());
            }
        }

        return $this->properties;
    }
}
