<?php
namespace Inti\Gath\Repository;

use Inti\Gath\ClientInterface;
use Laminas\Hydrator\HydratorInterface;

/**
 * Class AbstractRepository
 *
 * @package Inti\Gath\Repository
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath
 */
abstract class AbstractRepository
{
    /** @var ClientInterface */
    protected $client;
    /** @var HydratorInterface */
    protected $hydrator;

    /**
     * Konstruktor.
     *
     * @param ClientInterface $client
     * @param HydratorInterface $hydrator
     */
    public function __construct(ClientInterface $client, HydratorInterface $hydrator)
    {
        $this->client = $client;
        $this->hydrator = $hydrator;
    }
}
