<?php
namespace Inti\Gath\Wp;

use Inti\Wp\Plugin\Service\PluginManager;

/**
 * Konfiguracija modula.
 *
 * @package Inti\Gath\Wp
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath
 */
final class ConfigProvider
{
    /**
     * @return array
     */
    public function __invoke(): array
    {
        return [
            'dependencies' => [
                'factories' => [
                    ImageManager::class => ImageManagerFactory::class,
                ],
            ],

            PluginManager::class => [
                'factories' => [
                    Plugin\GathAttributes::class => Plugin\GathAttributesFactory::class,
                    Plugin\GathCategories::class => Plugin\GathCategoriesFactory::class,
                    Plugin\GathImages::class => Plugin\GathImagesFactory::class,
                    Plugin\GathImageUpload::class => Plugin\GathImagesFactory::class,
                    Plugin\GathPrices::class => Plugin\GathPricesFactory::class,
                    Plugin\GathProducts::class => Plugin\GathProductsFactory::class,
                    Plugin\GathStock::class => Plugin\GathStockFactory::class,
                    Plugin\GathTires::class => Plugin\GathTiresFactory::class,
                ],
            ],
        ];
    }
}
