<?php
namespace Inti\Gath\Wp\Plugin;

use Inti\Gath\Model\Repository\AttributeRepository;
use Inti\Gath\Model\Repository\CategoryRepository;
use Inti\Gath\Model\Repository\RepositoryManager;
use Inti\WordPress\Plugin\PluginInterface;
use Psr\Container\ContainerInterface;

final class GathAttributesFactory
{
    /**
     * @param ContainerInterface $container
     * @return PluginInterface
     */
    public function __invoke(ContainerInterface $container): PluginInterface
    {
        /** @var RepositoryManager $repos */
        $repos = $container->get(RepositoryManager::class);
        /** @var AttributeRepository $attributes */
        $attributes = $repos->get(AttributeRepository::class);
        /** @var CategoryRepository $categories */
        $categories = $repos->get(CategoryRepository::class);

        return new GathAttributes($attributes, $categories);
    }
}
