<?php
namespace Inti\Gath\Wp\Plugin;

use Inti\Gath\Model\Repository\CategoryRepository;
use Inti\Gath\Model\Repository\RepositoryManager;
use Inti\Gath\Wp\ImageManager;
use Inti\WordPress\Plugin\PluginInterface;
use Psr\Container\ContainerInterface;

/**
 * Class GathCategoriesFactory
 *
 * @package Inti\Gath\Wp\Plugin
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath
 */
final class GathCategoriesFactory
{
    /**
     * @param ContainerInterface $container
     * @return PluginInterface
     */
    public function __invoke(ContainerInterface $container): PluginInterface
    {
        /** @var RepositoryManager $repos */
        $repos = $container->get(RepositoryManager::class);
        /** @var CategoryRepository $repo */
        $repo = $repos->get(CategoryRepository::class);
        /** @var ImageManager $imageManager */
        $imageManager = $container->get(ImageManager::class);

        return new GathCategories($repo, $imageManager);
    }
}
