<?php
namespace Inti\Gath\Wp\Plugin;

use Interop\Container\ContainerInterface;
use Inti\Gath\Wp\ImageManager;
use Laminas\ServiceManager\Factory\FactoryInterface;

/**
 * Class ImageUploadPluginFactory
 *
 * @package Inti\Gath\Wp\Plugin
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath
 */
final class GathImagesFactory implements FactoryInterface
{
    /**
     * @param ContainerInterface $container
     * @param string $requestedName
     * @param array|null $options
     * @return object
     */
    public function __invoke(ContainerInterface $container, $requestedName, array $options = null): object
    {
        /** @var ImageManager $imageManager */
        $imageManager = $container->get(ImageManager::class);

        return new $requestedName($imageManager);
    }
}
