<?php
namespace Inti\Gath\Wp\Widget;

use Interop\Container\ContainerInterface;
use Inti\Gath\Model\Repository\RepositoryManager;
use Inti\Gath\Model\Repository\TireRepository;
use Laminas\ServiceManager\Factory\FactoryInterface;

/**
 * Class TireFilterFactory
 *
 * @package Inti\Gath\Wp\Widget
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath
 */
final class TireFilterWidgetFactory implements FactoryInterface
{
    /**
     * @param ContainerInterface $container
     * @param string $requestedName
     * @param array|null $options
     * @return object|void
     */
    public function __invoke(ContainerInterface $container, $requestedName, array $options = null)
    {
        /** @var RepositoryManager $repos */
        $repos = $container->get(RepositoryManager::class);
        $repo = $repos->get(TireRepository::class);

        return new TireFilterWidget($repo);
    }
}
