<?php
namespace IntiTest\Gath\Model\Hydrator;

use Inti\Gath\Model\Entity\ProductStock;
use Inti\Gath\Model\Hydrator\ProductStockHydrator;
use PHPUnit\Framework\TestCase;

/**
 * Class ProductStockHydratorTest
 *
 * @package IntiTest\Gath\Model\Hydrator
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath
 */
final class ProductStockHydratorTest extends TestCase
{
    public function testCanHydrateStockByWarehouses()
    {
        $hydrator = new ProductStockHydrator();
        /** @var ProductStock $productStock */
        $productStock = $hydrator->hydrate([
            'Stock' => 18,
            'Stock_04' => 3,
            'Stock_12' => 8,
            'Stock_43' => 7,
        ], new ProductStock());

        $this->assertEquals(18, $productStock->getStock());
        $this->assertEquals(3, $productStock->getStock('04'));
        $this->assertEquals(8, $productStock->getStock('12'));
        $this->assertEquals(7, $productStock->getStock('43'));
    }
}
