<?php
namespace IntiTest\Gath\Model\Repository;

use Inti\Gath\Model\Entity\ProductPrice;
use Inti\Gath\Model\Repository\ProductPriceRepository;
use Inti\Gath\Model\Repository\RepositoryManager;
use PHPUnit\Framework\TestCase;
use Psr\Container\ContainerInterface;

/**
 * Class ProductPriceRepositoryTest
 *
 * @package IntiTest\Gath\Model\Repository
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath
 */
final class ProductPriceRepositoryTest extends TestCase
{
    public function testCanGetProductPricesBySku()
    {
        /** @var ContainerInterface $container */
        $container = include __DIR__ . '/../../container.php';
        /** @var RepositoryManager $repos */
        $repos = $container->get(RepositoryManager::class);
        /** @var ProductPriceRepository $repo */
        $repo = $repos->get(ProductPriceRepository::class);

        $productPrices = $repo->getByProductSku(['PROD01', 'PROD02']);
        $this->assertCount(2, $productPrices);

        $productPrice = $productPrices[0];
        $this->assertInstanceOf(ProductPrice::class, $productPrice);
        $this->assertEquals(2, $productPrice->getProductId());
        $this->assertEquals('PROD01', $productPrice->getProductSku());
        $this->assertEquals('HRK', $productPrice->getCurrency());
//        $this->assertTrue($productPrice->isOnSale());
//        $this->assertEquals(12.5, $productPrice->getPrice());
        $this->assertFalse($productPrice->isPriceHidden());
    }
}
