<?php
namespace IntiTest\Gath\Model\Repository;

use Inti\Gath\Model\Entity\Product;
use Inti\Gath\Model\Repository\ProductRepository;
use Inti\Gath\Model\Repository\RepositoryManager;
use PHPUnit\Framework\TestCase;
use Psr\Container\ContainerInterface;

/**
 * Class ProductRepositoryTest
 *
 * @package IntiTest\Gath\Model\Repository
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath
 */
final class ProductRepositoryTest extends TestCase
{
    public function testCanGetAllProducts()
    {
        /** @var ContainerInterface $container */
        $container = include __DIR__ . '/../../container.php';
        /** @var RepositoryManager $repos */
        $repos = $container->get(RepositoryManager::class);
        /** @var ProductRepository $repo */
        $repo = $repos->get(ProductRepository::class);

        $products = $repo->getAll();
        $this->assertContainsOnlyInstancesOf(Product::class, $products);
    }
}
