<?php
namespace IntiTest\Gath\Model\Repository;

use Inti\Gath\Model\Entity\ProductStock;
use Inti\Gath\Model\Repository\ProductStockRepository;
use Inti\Gath\Model\Repository\RepositoryManager;
use PHPUnit\Framework\TestCase;
use Psr\Container\ContainerInterface;

/**
 * Class ProductStockRepositoryTest
 *
 * @package IntiTest\Gath\Model\Repository
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath
 */
final class ProductStockRepositoryTest extends TestCase
{
    public function testCanGetProductStockBySkus()
    {
        /** @var ContainerInterface $container */
        $container = include __DIR__ . '/../../container.php';
        /** @var RepositoryManager $repos */
        $repos = $container->get(RepositoryManager::class);
        /** @var ProductStockRepository $repo */
        $repo = $repos->get(ProductStockRepository::class);

        $productStocks = $repo->getByProductSku(['PROD01', 'PROD02']);
        $this->assertCount(2, $productStocks);

        $productStock = $productStocks[0];
        $this->assertInstanceOf(ProductStock::class, $productStock);
        $this->assertEquals(2, $productStock->getProductId());
        $this->assertEquals('PROD01', $productStock->getProductSku());
        $this->assertEquals(0, $productStock->getPurchaseStep());
        $this->assertEquals(150, $productStock->getStock());
    }
}
